//
// slice_helper.go
// Copyright (C) 2022 tiglog <me@tiglog.com>
//
// Distributed under terms of the MIT license.
//

package helper

func InStringSlice(need string, haystack []string) bool {
	for _, e := range haystack {
		if e == need {
			return true
		}
	}
	return false
}

func InIntSlice(need int, haystack []int) bool {
	for _, e := range haystack {
		if e == need {
			return true
		}
	}
	return false
}

func IsAnySlice(v interface{}) bool {
	_, ok := v.([]interface{})
	return ok
}

func IsStringSlice(v interface{}) bool {
	_, ok := v.([]string)
	return ok
}

func IsIntSlice(v interface{}) bool {
	_, ok := v.([]int)
	return ok
}

func DeleteIntSlice(a []int, elt int) []int {
	var size = len(a)
	for i := 0; i < size; i++ {
		if a[i] == elt {
			a = append(a[:i], a[i+1:]...)
			i--
		}
	}
	return a
}

func DeleteStrSlice(a []string, elt string) []string {
	var size = len(a)
	for i := 0; i < size; i++ {
		if a[i] == elt {
			a = append(a[:i], a[i+1:]...)
			i--
		}
	}
	return a
}

func DeleteSlice(a []any, elt any) []any {
	var size = len(a)
	for i := 0; i < size; i++ {
		if a[i] == elt {
			a = append(a[:i], a[i+1:]...)
			i--
		}
	}
	return a
}
